config/routes.rb
require 'sidekiq/web'
require 'sidekiq/cron/web'
require 'sidekiq-status/web'

Rails.application.routes.draw do # rubocop:todo Metrics/BlockLength

  devise_for :users, controllers: {
    registrations: 'users/registrations'
  }

  root 'home#index'
  get '/about', to: 'home#about', as: 'about'
  get '/terms', to: 'home#licence', as: 'terms'
  get '/stats', to: 'home#stats', as: 'stats'
  get '/profile', to: 'profile#index', as: 'profile'

  namespace 'api' do
    namespace 'v1' do
      get '/', to: 'home#index'
      get '/me', to: 'users#me'

      resources :kingdoms, only: %i[index show]
      resources :subkingdoms, only: %i[index show]
      resources :division_orders, only: %i[index show]
      resources :division_classes, only: %i[index show]
      resources :divisions, only: %i[index show]
      resources :families, only: %i[index show] do
        resources :genus, only: %i[index show]
      end
      resources :genus, only: %i[index show] do
        resources :plants, only: %i[index show]
        resources :species, only: %i[index show]
      end

      resources :plants, only: %i[index show] do
        resources :species, only: %i[index show]
        post '/report', action: :report, on: :member
        get '/search', action: :search, on: :collection
      end

      resources :species, only: %i[index show] do
        resources :record_corrections, only: %i[index], path: 'corrections'
        post '/report', action: :report, on: :member
        get '/search', action: :search, on: :collection
      end

      resources :record_corrections, path: 'corrections', only: %i[index show] do
        post '/:record_type/:record_id', to: 'record_corrections#create', on: :collection
        get :mine, to: 'record_corrections#index', on: :collection, mine: true
      end

      resources :zones, path: 'distributions', only: %i[index show] do
        resources :plants, only: %i[index show]
        resources :species, only: %i[index show]
      end
    end

    namespace 'auth' do
      post '/claim', to: 'auth#claim'
    end

    match '*all', controller: 'api', action: 'cors_preflight_check', via: [:options]
  end

  namespace 'explore' do
    get '/', to: 'species#index'
    get '/data', to: 'data#index'
    resources :species, only: %i[index show] do
      resources :record_corrections, only: %i[index], path: 'corrections'
    end
    resources :genus, only: %i[index show] do
    end
    resources :record_corrections, path: 'corrections', only: %i[index show] do

    end
  end

  namespace 'management' do
    authenticate :user, ->(user) { user.admin? } do
      mount PgHero::Engine, at: 'pghero'
      mount Sidekiq::Web => '/sidekiq'
    end

    get '/', to: 'plants#index'

    resources :users
    resources :user_queries do
      get :stats, on: :collection
    end
    resources :subkingdoms
    resources :species_proposals
    resources :species_images do
      get :chaos, on: :collection
    end
    resources :record_corrections do
      patch :accept, on: :member
      patch :reject, on: :member
    end

    resources :species do
      patch :refresh, on: :member
    end

    resources :sessions
    resources :plants
    resources :major_groups
    resources :kingdoms
    resources :genuses
    resources :foreign_sources_plants
    resources :foreign_sources
    resources :families
    resources :divisions
    resources :division_orders
    resources :division_classes
  end

end

app/controllers/api/v1/species_controller.rb
class Api::V1::SpeciesController < Api::ApiController

  include WithCachedCount

  FILTERABLE_FIELDS = %w[
    author
    bloom_months
    common_name
    days_to_harvest
    duration
    establishment
    edible
    edible_part
    family_common_name
    family_name
    flower_color
    flower_conspicuous
    foliage_color
    foliage_texture
    fruit_color
    fruit_conspicuous
    fruit_months
    fruit_seed_persistence
    genus_name
    growth_form
    growth_habit
    growth_months
    growth_rate
    leaf_retention
    ligneous_type
    rank
    scientific_name
    status
    vegetable
  ].freeze

  FILTERABLE_NOT_FIELDS = %w[
    author
    average_height_cm
    bibliography
    common_name
    days_to_harvest
    edible_part
    family_common_name
    family_name
    flower_color
    flower_conspicuous
    foliage_color
    foliage_texture
    frost_free_days_minimum
    fruit_color
    fruit_conspicuous
    fruit_seed_persistence
    genus_name
    ground_humidity
    growth_form
    growth_habit
    growth_rate
    image_url
    images_count
    leaf_retention
    light
    ligneous_type
    maximum_height_cm
    maximum_precipitation_mm
    maximum_temperature_deg_c
    maximum_temperature_deg_f
    minimum_precipitation_mm
    minimum_root_depth_cm
    minimum_temperature_deg_c
    minimum_temperature_deg_f
    ph_maximum
    ph_minimum
    planting_days_to_harvest
    planting_row_spacing_cm
    planting_spread_cm
    rank
    scientific_name
    soil_nutriments
    soil_salinity
    soil_texture
    sources_count
    status
    synonyms_count
    toxicity
    vegetable
    year
  ].freeze

  ORDERABLE_FIELDS = %w[
    atmospheric_humidity
    author
    average_height_cm
    bibliography
    common_name
    duration
    days_to_harvest
    edible
    family_common_name
    family_name
    flower_color
    flower_conspicuous
    foliage_color
    foliage_texture
    frost_free_days_minimum
    fruit_color
    fruit_conspicuous
    fruit_seed_persistence
    ground_humidity
    growth_form
    growth_habit
    growth_rate
    images_count
    leaf_retention
    light
    ligneous_type
    maximum_height_cm
    maximum_precipitation_mm
    maximum_temperature_deg_c
    maximum_temperature_deg_c
    maximum_temperature_deg_f
    maximum_temperature_deg_f
    minimum_precipitation_mm
    minimum_root_depth_cm
    minimum_temperature_deg_c
    minimum_temperature_deg_f
    ph_maximum
    ph_minimum
    planting_days_to_harvest
    planting_row_spacing_cm
    planting_spread_cm
    rank
    scientific_name
    soil_nutriments
    soil_salinity
    soil_texture
    sources_count
    status
    synonyms_count
    toxicity
    updated_at
    vegetable
    year
  ].freeze

  RANGEABLE_FIELDS = %w[
    atmospheric_humidity
    average_height_cm
    days_to_harvest
    frost_free_days_minimum
    ground_humidity
    images_count
    light
    maximum_height_cm
    maximum_precipitation_mm
    maximum_temperature_deg_c
    maximum_temperature_deg_f
    minimum_precipitation_mm
    minimum_root_depth_cm
    minimum_temperature_deg_c
    minimum_temperature_deg_f
    ph_maximum
    ph_minimum
    planting_days_to_harvest
    planting_row_spacing_cm
    planting_spread_cm
    soil_nutriments
    soil_salinity
    soil_texture
    sources_count
    synonyms_count
    toxicity
    year
  ].freeze

  def index
    @collection = collection

    links = collection_links(@collection, name: %i[species index])

    render_serialized_collection(
      @collection,
      SpeciesLightSerializer,
      links: links
    )
  end

  def show
    @resource = Species.friendly.find(params[:id])

    render_serialized_resource(
      @resource,
      SpeciesSerializer,
      meta: {
        images_count: @resource.images_count,
        sources_count: @resource.sources_count,
        synonyms_count: @resource.synonyms_count
      }.merge(resource_metadata(@resource))
    )
  end

  # Search on database
  # @TODO @deprecated
  def full_search
    puts 'full_search'
    @collection ||= collection
    @collection = apply_search(collection)
    @pagy, @collection = pagy(@collection)
    links = collection_links(@collection, name: %i[species index], scope: %i[search api v1])

    render_serialized_collection(
      @collection,
      SpeciesLightSerializer,
      links: links
    )
  end

  # Search on elasticsearch
  def search
    search = params.require(:q)
    search_params = search_params(
      filter_not_fields: Api::V1::SpeciesController::FILTERABLE_NOT_FIELDS,
      filter_fields: Api::V1::SpeciesController::FILTERABLE_FIELDS,
      order_fields: Api::V1::SpeciesController::ORDERABLE_FIELDS,
      range_fields: Api::V1::SpeciesController::RANGEABLE_FIELDS
    )
    options = {
      where: search_params[:where],
      includes: %i[synonyms genus plant],
      boost_by: [:gbif_score],
      fields: ['common_name^10', 'common_names^8', 'scientific_name^5', 'synonyms^3', 'author', 'genus', 'family', 'family_common_name', 'distributions'],
      order: search_params[:order]
    }.compact

    @collection = Species.pagy_search(search, options)
    @pagy, @collection = pagy_searchkick(@collection, items: (params[:limit] || 20).to_i)

    links = collection_links(@collection, name: %i[species index], scope: %i[search api v1])

    render_serialized_collection(
      @collection,
      SpeciesLightSerializer,
      links: links
    )
  end

  # Report an error
  def report
    @resource = Species.friendly.find(params[:id])
    rc = RecordCorrection.report!(
      record: @resource,
      user: current_user,
      change_type: params[:change_type] || 'update',
      notes: params[:notes]
    )
    render_serialized_resource(
      rc,
      RecordCorrectionSerializer,
      meta: resource_metadata(rc),
      status: :created
    )
  end

  def collection
    return @collection if @collection

    @collection = Genus.friendly.find(params[:genus_id]).species if params[:genus_id]
    @collection = Plant.friendly.find(params[:plant_id]).species if params[:plant_id]
    @collection = Zone.friendly.find(params[:zone_id].to_s.downcase).all_species if params[:zone_id]
    @collection ||= Species.all

    @collection = @collection.preload(:plant, :genus, :synonyms)

    @collection = apply_filters(@collection, FILTERABLE_FIELDS)
    @collection = apply_filters_not(@collection, FILTERABLE_NOT_FIELDS)
    @collection = apply_sort(@collection, ORDERABLE_FIELDS, default_sort: { gbif_score: :desc })
    @collection = apply_range(@collection, RANGEABLE_FIELDS)
    # @collection = apply_search(collection)

    @pagy, @collection = pagy(@collection)
    @collection
  end

end

app/controllers/explore/species_controller.rb
class Explore::SpeciesController < Explore::ExploreController
  before_action :set_species, only: %i[show edit update destroy refresh corrections]

  has_scope :vegetable, type: :boolean, allow_blank: true
  has_scope :edible, type: :boolean, allow_blank: true

  # GET /species
  # GET /species.json
  def index
    search = params[:search]
    @page_title = 'Explore plants and species'
    @page_keywords = 'explore, plants, search, species'

    if search.blank?
      @collection ||= Species.all.preload(:plant, :genus, :synonyms).order(wiki_score: :desc)
      @pagy, @collection = pagy(@collection)
    else
      options = {
        includes: %i[synonyms genus plant],
        boost_by: [:gbif_score],
        fields: ['common_name^10', 'common_names^8', 'scientific_name^5', 'synonyms^3', 'author', 'genus', 'family', 'family_common_name', 'distributions']
      }.compact

      @collection = Species.pagy_search(search, options)
      @pagy, @collection = pagy_searchkick(@collection, items: (params[:limit] || 20).to_i)
    end
  end

  # GET /species/1
  # GET /species/1.json
  def show
    ptitle = @species.scientific_name
    ptitle = "#{ptitle} (#{@species.common_name})" if @species.common_name
    @page_title = ptitle
    @page_description = "#{@species.scientific_name} is an #{@species.status} #{@species.rank} of the #{@species.family_name} family"
    @page_keywords    = [@species.scientific_name, @species.common_name, @species.family_name, @species.family_common_name, 'plant', 'explore'].compact.join(', ')

    set_meta_tags(
      image_src: @species.main_image_url,
      og: {
        title: @species.scientific_name,
        image: @species.main_image_url
      }
    )
  end

  # # GET /species/new
  # def new
  #   @species = Species.new
  # end

  # # GET /species/1/edit
  # def edit; end

  # # POST /species
  # # POST /species.json
  # def create
  #   @species = Species.new(species_params)

  #   respond_to do |format|
  #     if @species.save
  #       format.html { redirect_to [:management, @species], notice: 'Species was successfully created.' }
  #       format.json { render :show, status: :created, location: @species }
  #     else
  #       format.html { render :new }
  #       format.json { render json: @species.errors, status: :unprocessable_entity }
  #     end
  #   end
  # end

  # # PATCH/PUT /species/1
  # # PATCH/PUT /species/1.json
  # def update
  #   respond_to do |format|
  #     if @species.update(species_params)
  #       @species.update(reviewed_at: Time.zone.now)
  #       format.html { redirect_to [:management, @species], notice: 'Species was successfully updated.' }
  #       format.json { render :show, status: :ok, location: @species }
  #     else
  #       format.html { render :edit }
  #       format.json { render json: @species.errors, status: :unprocessable_entity }
  #     end
  #   end
  # end

  # # DELETE /species/1
  # # DELETE /species/1.json
  # def destroy
  #   @species.destroy
  #   respond_to do |format|
  #     format.html { redirect_to species_index_url, notice: 'Species was successfully destroyed.' }
  #     format.json { head :no_content }
  #   end
  # end

  # def refresh
  #   respond_to do |format|
  #     if @species
  #       Crawlers::SpeciesFetchWorker.perform_async(@species.slug)
  #       format.html { redirect_to [:management, @species], notice: 'Species refresh enqueued.' }
  #       format.json { render :show, status: :ok, location: @species }
  #     else
  #       format.html { redirect_to [:management, @species], notice: 'En error occured' }
  #       format.json { render json: @species.errors, status: :unprocessable_entity }
  #     end
  #   end
  # end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_species
    @species = Species.friendly.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def species_params # rubocop:todo Metrics/MethodLength
    params.require(:species).permit(
      :adapted_to_coarse_textured_soils,
      :adapted_to_fine_textured_soils,
      :adapted_to_medium_textured_soils,
      :anaerobic_tolerance,
      :atmospheric_humidity,
      :author,
      :bibliography,
      :biological_type,
      :biological_type_raw,
      :c_n_ratio,
      :caco_3_tolerance,
      :checked_at,
      :common_name,
      :complete_data,
      :dissemination,
      :dissemination_raw,
      :edible,
      :edible_part,
      :family_common_name,
      :flower_conspicuous,
      :foliage_texture,
      :frost_free_days_minimum,
      :fruit_conspicuous,
      :fruit_seed_persistence,
      :fruit_shape,
      :fruit_shape_raw,
      :full_token,
      :gbif_score,
      :ground_humidity,
      :growth_form,
      :growth_habit,
      :growth_rate,
      :hardiness_zone,
      :images_count,
      :inflorescence_form,
      :inflorescence_raw,
      :inflorescence_type,
      :inserted_at,
      :known_allelopath,
      :leaf_retention,
      :lifespan,
      :light,
      :ligneous_type,
      :maturation_order,
      :maturation_order_raw,
      :average_height_cm,
      :maximum_height_cm,
      :minimum_precipitation_mm,
      :maximum_precipitation_mm,
      :minimum_root_depth_cm,
      :maximum_temperature_deg_c,
      :maximum_temperature_deg_f,
      :minimum_temperature_deg_c,
      :minimum_temperature_deg_f,
      :nitrogen_fixation,
      :observations,
      :ph_maximum,
      :ph_minimum,
      :planting_days_to_harvest,
      :planting_description,
      :planting_row_spacing_cm,
      :planting_sowing_description,
      :planting_spread_cm,
      :pollinisation,
      :pollinisation_raw,
      :protein_potential,
      :rank,
      :reviewed_at,
      :scientific_name,
      :sexuality,
      :sexuality_raw,
      :shape_and_orientation,
      :slug,
      :soil_nutriments,
      :soil_salinity,
      :soil_texture,
      :sources_count,
      :status,
      :synonyms_count,
      :token,
      :toxicity,
      :vegetable,
      :year,
      :created_at,
      :updated_at,
      :genus_id,
      :main_species_id,
      :plant_id,
      :synonym_of_id,
      bloom_months: [],
      fruit_months: [],
      growth_months: [],
      duration: [],
      propagated_by: [],
      flower_color: [],
      fruit_color: [],
      foliage_color: [],
      edible_part: []
    )
  end

end

app/views/management/species/_form_foliage.html.erb
<div class="field is-horizontal">
  <div class="field-label is-normal">
    <%= form.label :foliage_texture %>
  </div>
  <div class="field-body">
    <div class="field">
      <%= form.simple_select :foliage_texture, Species.foliage_textures.keys, include_blank: true %>
    </div>
  </div>
</div>

<div class="field is-horizontal">
  <div class="field-label is-normal">
    <%= form.label :leaf_retention %>
  </div>
  <div class="field-body">
    <div class="field">
      <div class="control">
        <label class="radio"><%= form.radio_button :leaf_retention, "true" %> Yes</label>
        <label class="radio"><%= form.radio_button :leaf_retention, "false" %> No</label>
      </div>
    </div>
  </div>
</div>

<div class="field is-horizontal">
  <div class="field-label is-normal">
    <%= form.label :foliage_color %>
  </div>
  <div class="field-body">
    <div class="field">
      <div class="columns is-multiline">
        <% Species.foliage_colors.pairs.each do |k, v| %>
        <div class="column is-2-desktop is-3-tablet is-6-mobile">
          <%= form.label "foliage_color_#{v}" do %>
          <%= form.check_box :foliage_color, {multiple: true, id: "species_foliage_color_#{v}"}, v, nil %>
          <span class="color-round" style="<%= "color: #{v}"%>"></span>
          <span><%= k %></span>
          <% end %>
        </div>
        <% end %>
      </div>
    </div>

  </div>
</div>

app/views/management/species/edit.html.erb
<section class="section">
  <div class="container">
    <nav class="breadcrumb has-arrow-separator" aria-label="breadcrumbs">
      <ul>
        <li><%= @species.plant&.genus && link_to("Genus #{@species.plant&.genus&.name}", management_genuse_path(@species.plant&.genus))|| 'No genus' %></li>
        <li><%= link_to("Plant #{@species.plant.scientific_name}", management_plant_path(@species.plant)) %></li>
        <li class="is-active"><%= @species.plant&.main_species && link_to("Main species #{@species.plant&.main_species&.scientific_name}", management_species_path(@species.plant&.main_species)) || 'No main species' %></li>
      </ul>
    </nav>


    <p id="notice" class="notification is-info"><%= notice %></p>

    <h1 class="title">
      <%= @species.scientific_name %>
      <span class="tag is-info is-light"><%= @species.rank %></span>
      <sup>#<%= @species.id %></sup>
      <%= link_to  'Back', management_species_path(@species), class: 'button is-pulled-right' %>

    </h1>

    <div class="columns is-desktop">
      <div class="column">
        <%= render 'form', species: @species %>
      </div>
    </div>
    <%= link_to 'Show', management_species_path(@species) %> |
    <%= link_to 'Back', management_species_index_path %>
  </div>
</section>

app/views/management/species/new.html.erb
<h1>New Species</h1>

<%= render 'form', species: @species %>

<%= link_to 'Back', species_index_path %>

app/views/management/species/show.html.erb
<% cache [:species, :show, :main, @species.cache_key, @species.cache_version] do %>

<section class="section">
  <div class="container">
    <nav class="breadcrumb has-arrow-separator" aria-label="breadcrumbs">
      <ul>
        <li><%= @species.plant&.genus && link_to("Genus #{@species.plant&.genus&.name}", management_genuse_path(@species.plant&.genus))|| 'No genus' %></li>
        <li><%= link_to("Plant #{@species.plant.scientific_name}", management_plant_path(@species.plant)) %></li>
        <li class="is-active"><%= @species.plant&.main_species && link_to("Main species #{@species.plant&.main_species&.scientific_name}", management_species_path(@species.plant&.main_species)) || 'No main species' %></li>
      </ul>
    </nav>

    <p id="notice" class="notification is-info"><%= notice %></p>

    <h1 class="title">
      <%= @species.scientific_name %>
      <span class="tag is-info is-light"><%= @species.rank %></span>
      <sup>#<%= @species.id %></sup>
      <%= link_to 'Edit', edit_management_species_path(@species), class: 'button is-pulled-right' %>
    </h1>

    <div class="columns is-desktop">
      <div class="column">
        <h3 class="title is-4">General informations</h3>

        <%= field_desc(@species, :reviewed_at) %>
        <%= field_desc(@species, :images_count) %>
        <%= field_desc(@species, :sources_count) %>
        <%= field_desc(@species, :synonyms_count) %>
        <%= field_desc(@species, :gbif_score) %>

        <%= field_desc(@species, :author) %>
        <%= field_desc(@species, :year) %>
        <%= field_desc(@species, :bibliography) %>
        <%= field_desc(@species, :observations) %>

        <br />
        <h3 class="title is-4">Specifications</h3>

        <%= field_desc(@species, :ligneous_type) %>
        <%= field_desc(@species, :duration, :flags) %>
        <%= field_desc(@species, :growth_form) %>
        <%= field_desc(@species, :growth_habit) %>
        <%= field_desc(@species, :growth_rate) %>
        <%= field_desc(@species, :known_allelopath) %>
        <%= field_desc(@species, :lifespan) %>

        <%= field_desc(@species, :average_height_cm) %>
        <%= field_desc(@species, :maximum_height_cm) %>

        <%= field_desc(@species, :nitrogen_fixation) %>
        <%= field_desc(@species, :shape_and_orientation) %>

        <%= field_desc(@species, :toxicity) %>
        <%= field_desc(@species, :light) %>
        <%= field_desc(@species, :atmospheric_humidity) %>


        <%= field_desc(@species, :growth_months, :flags) %>
        <%= field_desc(@species, :bloom_months, :flags) %>
        <%= field_desc(@species, :fruit_months, :flags) %>

        <br />
        <h3 class="title is-4">Growth</h3>

        <%= field_desc(@species, :planting_description) %>
        <%= field_desc(@species, :planting_sowing_description) %>
        <%= field_desc(@species, :edible_part, :flags) %>
        <%= field_desc(@species, :planting_days_to_harvest) %>
        <%= field_desc(@species, :planting_row_spacing_cm) %>
        <%= field_desc(@species, :planting_spread_cm) %>
        <%= field_desc(@species, :ph_minimum) %>
        <%= field_desc(@species, :ph_maximum) %>
        <%= field_desc(@species, :minimum_temperature_deg_c) %>
        <%= field_desc(@species, :maximum_temperature_deg_c) %>
        <%= field_desc(@species, :minimum_precipitation_mm) %>
        <%= field_desc(@species, :maximum_precipitation_mm) %>
        <%= field_desc(@species, :minimum_root_depth_cm) %>

        <%= field_desc(@species, :soil_nutriments) %>
        <%= field_desc(@species, :soil_salinity) %>
        <%= field_desc(@species, :ground_humidity) %>
        <%= field_desc(@species, :soil_texture) %>
        <%= field_desc(@species, :adapted_to_fine_textured_soils) %>
        <%= field_desc(@species, :adapted_to_medium_textured_soils) %>
        <%= field_desc(@species, :adapted_to_coarse_textured_soils) %>

        <br />
        <h3 class="title is-4">Fruit / Seed</h3>

        <%= field_desc(@species, :fruit_conspicuous) %>
        <%= field_desc(@species, :fruit_seed_persistence) %>
        <%= field_desc(@species, :fruit_shape) %>
        <%= field_desc(@species, :fruit_shape_raw) %>
        <%= field_desc(@species, :fruit_color, :flags) %>

        <br />
        <h3 class="title is-4">Foliage</h3>

        <%= field_desc(@species, :foliage_texture) %>
        <%= field_desc(@species, :leaf_retention) %>
        <%= field_desc(@species, :foliage_color, :flags) %>

        <br />
        <h3 class="title is-4">Flower</h3>

        <%= field_desc(@species, :flower_conspicuous) %>
        <%= field_desc(@species, :flower_color, :flags) %>
        <%= field_desc(@species, :sexuality) %>
        <%= field_desc(@species, :pollinisation) %>
        <%= field_desc(@species, :pollinisation_raw) %>
        <%= field_desc(@species, :maturation_order) %>
        <%= field_desc(@species, :maturation_order_raw) %>
        <%= field_desc(@species, :dissemination) %>
        <%= field_desc(@species, :dissemination_raw) %>
        <%= field_desc(@species, :inflorescence_form) %>
        <%= field_desc(@species, :inflorescence_type) %>
        <%= field_desc(@species, :inflorescence_raw) %>

        <br />
        <h3 class="title is-4">Other</h3>

        <%= field_desc(@species, :common_name) %>
        <%= field_desc(@species, :complete_data) %>
        <%= field_desc(@species, :family_common_name) %>
        <%= field_desc(@species, :anaerobic_tolerance) %>
        <%= field_desc(@species, :biological_type) %>
        <%= field_desc(@species, :biological_type_raw) %>
        <%= field_desc(@species, :c_n_ratio) %>
        <%= field_desc(@species, :caco_3_tolerance) %>
        <%= field_desc(@species, :edible) %>
        <%= field_desc(@species, :foliage_color, :flags) %>
        <%= field_desc(@species, :foliage_texture) %>
        <%= field_desc(@species, :frost_free_days_minimum) %>

        <%= field_desc(@species, :hardiness_zone) %>
        <%= field_desc(@species, :inserted_at) %>
        <%= field_desc(@species, :leaf_retention) %>
        <%
=begin%>
        <%= field_desc(@species, :minimum_planting_density_unit) %>
        <%
=end%>
        <%
=begin%>
        <%= field_desc(@species, :minimum_planting_density_cm) %>
        <%
=end%>
        <%= field_desc(@species, :propagated_by) %>
        <%= field_desc(@species, :protein_potential) %>
        <%= field_desc(@species, :reviewed_at) %>
        <%= field_desc(@species, :status) %>
        <%= field_desc(@species, :vegetable) %>

      </div>
      <div class="column">
        <h3 class="title is-4">Sources</h3>
        <ul>
          <% @species&.foreign_sources_plants&.each do |fsp| %>
          <li><b><%= fsp.foreign_source.name %></b>: <%= fsp.fid %> (<a target="_blank" href="<%= fsp.full_url %>"><%= fsp.full_url ? "Source" : 'No url' %></a>)</li>
          <% end %>
        </ul>
        <br />
        <h3 class="title is-4">Images</h3>
        <% @species&.species_images&.group_by(&:part)&.each do |part, images| %>
        <h3 class="title is-6"><%= images.first.part %></h3>

        <div class="columns is-multiline is-desktop">
          <% images.first(4).each do |spi| %>
          <div class="column">
            <img style="max-width: 128px; max-height: 128px" src="<%= spi.image_url %>">
          </div>
          <% end %>
        </div>
        <% if images.length > 4 %>
        <span>And <%= images.length - 4 %> more...</span>
        <% end %>
        <% end %>

        <h3 class="title is-4">Common names</h3>
        <ul>
          <% @species&.common_names.where(lang: %w(fr en))&.group_by(&:lang)&.each do |lang, names| %>
          <li><b><%= lang %></b>: <%= names.pluck(:name).join(', ') %></li>
          <% end %>
        </ul>
      </div>
    </div>
    <%= link_to 'Edit', edit_management_species_path(@species) %> |
    <%= link_to 'Back', management_species_index_path %>
  </div>
</section>
<% end %>